# global attribute
gnowstatus = "micoff"
curvemove = 'cubic-bezier(0.4, 0, 0.2, 1)'

#layers
bg = new Layer 
	x:0, y:0, width:750, height:1334, image:"images/gnow.png"
bgmask = new Layer width:144,height:144,borderRadius:72
color = new Layer width:144,height:144,borderRadius:72,shadowY:4,shadowBlur:8,shadowColor:'rgba(0,0,0,0.2)'

#empty layer to manipulate the color
rgbaslider = new Layer backgroundColor:''

# set the color
rcolor = 255
gcolor = 255
bcolor = 255

#map the color to layer
rgbaslider.x = rcolor
rgbaslider.y = gcolor
rgbaslider.z = bcolor

#this is color of layer 'color'
color.backgroundColor='rgba('+rcolor+','+gcolor+','+bcolor+',1)'
color.centerX()

color.y = 828

#just a mask for material design
bgmask.x = color.x
bgmask.y = color.y
bgmask.backgroundColor = color.backgroundColor


#event, I think you can do this with states but anyway...
color.on Events.Click,->
	
	if gnowstatus is "micoff"
		rgbaslider.animate
			properties:
				x:255
				y:62
				z:62
			curve:curvemove
			time:0.6
		
		color.scale = 0.8
		color.animate
			properties:
				scale:1
				y:1100
			curve:curvemove
			time:0.4
			
		bgmask.animate
			properties:
				scale:20
				opacity:1
			curve:curvemove
			time:0.4
		
		icmicon.animate
			properties:
				opacity:1
			curve:curvemove
			time:0.6
		
		icmic.opacity = 0
			
		gnowstatus = "micon"

	else 

		rgbaslider.animate
			properties:
				x:255
				y:255
				z:255
			curve:curvemove
			time:0.4
		
		color.scale = 0.9
		color.animate
			properties:
				scale:1
				y:828
			curve:curvemove
			time:0.4
			
		bgmask.animate
			properties:
				scale:1
				opacity:0.5
			curve:curvemove
			time:0.6
		
		icmicon.animate
			properties:
				opacity:0
			curve:curvemove
			time:0.7

		icmic.opacity = 1
			
		gnowstatus = "micoff"

#where magic happens
rgbaslider.on "change:x","change:y","change:z",->

	rcolor = Math.floor(rgbaslider.x)		
	gcolor = Math.floor(rgbaslider.y)		
	bcolor = Math.floor(rgbaslider.z)		
	
	color.backgroundColor='rgba('+rcolor+','+gcolor+','+bcolor+',1)'


#well, we need mic 
icmic = new Layer 
	x:0, y:0, width:72, height:72, image:"images/icmic_off.png",superLayer:color
icmic.center()
icmicon = new Layer 
	x:0, y:0, width:72, height:72, image:"images/icmic_on.png",superLayer:color,opacity:0
icmicon.center()
